import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class ReplaceDialog extends JDialog
{
  protected JFrame parentWindow;
  protected TwoContentArea contentArea;
  protected JTextField findText;
  protected JTextField replaceText;
  protected JCheckBox matchCaseBox;

  public ReplaceDialog(JFrame myParentWindow, TwoContentArea myContentArea)
  {
    super(myParentWindow, "Replace", false);
    parentWindow = myParentWindow;
    contentArea = myContentArea;

    getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.X_AXIS));
      JPanel leftPanel = new JPanel();
      leftPanel.setLayout(new GridLayout(4, 1, 5, 5));
      leftPanel.setBorder(new EmptyBorder(5, 5, 5, 2));
        JPanel findPanel = new JPanel();
        findPanel.setLayout(new BoxLayout(findPanel, BoxLayout.X_AXIS));
          JLabel findLabel = new JLabel("Find What:");
          findText = new JTextField(15);
          findLabel.setLabelFor(findText);
          findPanel.add(findLabel);
          findPanel.add(findText);
        leftPanel.add(findPanel);
        JPanel replacePanel = new JPanel();
        replacePanel.setLayout(new BoxLayout(replacePanel, BoxLayout.X_AXIS));
          JLabel replaceLabel = new JLabel("Replace With:");
          replaceText = new JTextField(15);
          replaceLabel.setLabelFor(replaceText);
          replacePanel.add(replaceLabel);
          replacePanel.add(replaceText);
        leftPanel.add(replacePanel);
        matchCaseBox = new JCheckBox("Match Case", false);
        leftPanel.add(matchCaseBox);
      getContentPane().add(leftPanel);
      JPanel buttonPanel = new JPanel();
      buttonPanel.setLayout(new GridLayout(4, 1, 5, 5));
      buttonPanel.setBorder(new EmptyBorder(5, 3, 5, 5));
        JButton findNextButton = new JButton("Find Next");
        findNextButton.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent event)
        {
          if(contentArea.find(findText.getText(), matchCaseBox.isSelected(), true))
            JOptionPane.showMessageDialog(parentWindow, "Cannot find specified text");
        } });
        buttonPanel.add(findNextButton);
        JButton replaceButton = new JButton("Replace");
        replaceButton.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent event)
        {
          if(!contentArea.replace(findText.getText(), replaceText.getText(), matchCaseBox.isSelected()))
            JOptionPane.showMessageDialog(parentWindow, "Cannot find next occurance of specified text");
        } });
        buttonPanel.add(replaceButton);
        JButton replaceAllButton = new JButton("Replace All");
        replaceAllButton.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent event)
        {
          contentArea.replaceAll(findText.getText(), replaceText.getText(), matchCaseBox.isSelected());
        } });
        buttonPanel.add(replaceAllButton);
        JButton cancelButton = new JButton("Cancel");
        cancelButton.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent event)
          { dispose(); } });
        buttonPanel.add(cancelButton);
      getContentPane().add(buttonPanel);
    pack();
    setLocationRelativeTo(parentWindow);
    setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
    setResizable(false);
    setVisible(true);
  }
}
