import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class FindDialog extends JDialog
{
  protected JFrame parentWindow;
  protected TwoContentArea contentArea;
  protected JRadioButton downButton;
  protected JCheckBox matchCaseBox;
  protected JTextField findText;

  public FindDialog(JFrame myParentWindow, TwoContentArea myContentArea)
  {
    super(myParentWindow, "Find", false);
    parentWindow = myParentWindow;
    contentArea = myContentArea;

    getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.X_AXIS));
      JPanel leftPanel = new JPanel();
      leftPanel.setLayout(new BoxLayout(leftPanel, BoxLayout.Y_AXIS));
      leftPanel.setBorder(new EmptyBorder(5, 5, 5, 2));
        JPanel findPanel = new JPanel();
        findPanel.setLayout(new BoxLayout(findPanel, BoxLayout.X_AXIS));
          JLabel findLabel = new JLabel("Find What:");
          findText = new JTextField(15);
          findLabel.setLabelFor(findText);
          findPanel.add(findLabel);
          findPanel.add(findText);
        leftPanel.add(findPanel);
        JPanel optionPanel = new JPanel();
        optionPanel.setLayout(new BoxLayout(optionPanel, BoxLayout.X_AXIS));
          matchCaseBox = new JCheckBox("Match Case", false);
          optionPanel.add(matchCaseBox);
          JPanel directionPanel = new JPanel();
          directionPanel.setLayout(new BoxLayout(directionPanel, BoxLayout.X_AXIS));
          directionPanel.setBorder(new TitledBorder(new EtchedBorder(), "Direction"));
            ButtonGroup directionGroup = new ButtonGroup();
              JRadioButton upButton = new JRadioButton("Up");
              directionGroup.add(upButton);
            directionPanel.add(upButton);
              downButton = new JRadioButton("Down");
              directionGroup.add(downButton);
              downButton.setSelected(true);
            directionPanel.add(downButton);
          optionPanel.add(directionPanel);
        leftPanel.add(optionPanel);
      getContentPane().add(leftPanel);
      JPanel buttonPanel = new JPanel();
      buttonPanel.setLayout(new GridLayout(2, 1, 5, 5));
      buttonPanel.setBorder(new EmptyBorder(5, 3, 5, 5));
        JButton findNextButton = new JButton("Find Next");
        findNextButton.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent event)
        {
          if(contentArea.find(findText.getText(), matchCaseBox.isSelected(), downButton.isSelected()))
            JOptionPane.showMessageDialog(parentWindow, "Cannot find specified text");
        } });
        buttonPanel.add(findNextButton);
        JButton cancelButton = new JButton("Cancel");
        cancelButton.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent event)
          { dispose(); } });
        buttonPanel.add(cancelButton);
      getContentPane().add(buttonPanel);
    pack();
    setLocationRelativeTo(parentWindow);
    setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
    setResizable(false);
    setVisible(true);
  }
}
