/*
 * ClipboardObject.java
 *
 * Created on April 5, 2002, 10:19 PM
 */

/**
 *
 * @author  Marshall
 * @version 
 */
import java.awt.*;
import java.awt.datatransfer.*;
import java.io.*;
import java.awt.image.*;
import java.lang.*;

//might have to implement ClipboardOwner
public class ClipboardObject implements TerpClipboardInterface, Transferable, ClipboardOwner {

    private BufferedImage current;
    static public DataFlavor imageFlavor;
    static public DataFlavor stringFlavor;
    private DataFlavor [] supportedFlavors;	  

    /** Creates new ClipboardObject */
    public ClipboardObject(BufferedImage in) {
        BufferedImage temp = new BufferedImage(in.getWidth(), in.getHeight(),BufferedImage.TYPE_INT_RGB);
        Graphics2D g2d = temp.createGraphics();
        g2d.drawImage(in,null,0,0);
        current = temp;
        
        try {
            imageFlavor = new DataFlavor (Class.forName ("java.awt.image.BufferedImage"), "Buffered Image");
            stringFlavor = new DataFlavor (Class.forName ("java.lang.String"), "String");
            supportedFlavors = new DataFlavor[2];
            supportedFlavors[0] = imageFlavor;
            supportedFlavors[1] = stringFlavor;
        }
        catch (ClassNotFoundException e) {
            e.toString();
        }
    }

    public synchronized DataFlavor [] getTransferDataFlavors () {
        return (supportedFlavors);
    }

    public boolean isDataFlavorSupported (DataFlavor parFlavor) {
        return (parFlavor.equals (imageFlavor));
    }
    
    public Object getTransferData(DataFlavor dataFlavor) throws java.awt.datatransfer.UnsupportedFlavorException, java.io.IOException {
        /*
         *Returns an object that identifies the actual data to be retrieved from 
         *the clipboard. The object returned depends on the DataFlavor object that 
         *is passed as an argument. This object must be cast to a class that is 
         *appropriate for the DataFlavor object
         */
        //For us I don't think it matters 
        if ( !dataFlavor.equals(imageFlavor) )
            return current;
        return null;
    }
    
    public int copiedFrom() {
        return TerpClipboardInterface.PAINT;
    }
        
    public String getString() {
        return new String("Faint");
    }
    
    public BufferedImage getImage() {
        return current;
    }
    
    public void lostOwnership(Clipboard clipboard, Transferable transferable) {
        //System.out.println ("Lost ownership");
    }
    
}
