import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.image.*;
import java.awt.geom.*;


public class brushTool implements ourTool {
    public final int DOT1 = 1;
    public final int DOT2 = 2;
    public final int DOT3 = 3;
    public final int SQUARE1 = 4;
    public final int SQUARE2 = 5;
    public final int SQUARE3 = 6;
    public final int RIGHT1 = 7;
    public final int RIGHT2 = 8;
    public final int RIGHT3 = 9;
    public final int LEFT1 = 10;
    public final int LEFT2 = 11;
    public final int LEFT3 = 12;
    
    BufferedImage brushImage;
    private int brushType;
    Graphics2D g2D;
    private int prevX, prevY;
    
    public brushTool() {
        super();
        brushType = DOT1;
        setBrushType(brushType);
    }
    
    public void clickAction(MouseEvent mevt, main_canvas theCanvas) {
        
        int x, y;
        
        x = theCanvas.canvasScale(mevt.getX());
        y = theCanvas.canvasScale(mevt.getY());
        brushImage = theCanvas.getBufferedImage();
        g2D = brushImage.createGraphics();
        theCanvas.setBufferedImage(brushImage);
        
        if (!SwingUtilities.isLeftMouseButton(mevt)) {
            g2D.setColor(theCanvas.left_color);
        } else {
            g2D.setColor(theCanvas.right_color);
        }
        switch (brushType) {
            case DOT1:
                if (SwingUtilities.isLeftMouseButton(mevt)) {
                    brushImage.setRGB(x,y,theCanvas.left_color.getRGB());
                } else {
                    brushImage.setRGB(x,y,theCanvas.right_color.getRGB());
                }
            break;
            case LEFT1:
            case LEFT2:
            case LEFT3:
            case RIGHT1:
            case RIGHT2:
            case RIGHT3:
                g2D.draw(drawBrush(x,y));
                break;
            default:
            g2D.fill(drawBrush(x,y));    
        }
        prevX = x;
        prevY = y;
    }
    
    public void dragAction(MouseEvent mevt, main_canvas theCanvas) {
       
        int x, y;
        int rise, run;
        double tempY;
        
        x = theCanvas.canvasScale(mevt.getX());
        y = theCanvas.canvasScale(mevt.getY());
        //g2D = brushImage.createGraphics();
        if (SwingUtilities.isLeftMouseButton(mevt)) {
            g2D.setColor(theCanvas.left_color);
        } else {
            g2D.setColor(theCanvas.right_color);
        }
        /*switch (brushType) {
            case DOT1:
            case LEFT1:
            case LEFT2:
            case LEFT3:
            case RIGHT1:
            case RIGHT2:
            case RIGHT3:
                g2D.draw(drawBrush(x,y));
                break;
            default:
            g2D.fill(drawBrush(x,y));    
        }*/
        drawStuff(mevt,x,y,theCanvas);
        theCanvas.repaint();    
        prevX = x;
        prevY = y;
    }
    
    public void mouseReleaseAction(MouseEvent mevt, main_canvas theCanvas) {
        
        int x, y;
        
        x = theCanvas.canvasScale(mevt.getX());
        y = theCanvas.canvasScale(mevt.getY());
        //g2D = brushImage.createGraphics();
        if (SwingUtilities.isLeftMouseButton(mevt)) {
            g2D.setColor(theCanvas.left_color);
        } else {
            g2D.setColor(theCanvas.right_color);
        }
        /*switch (brushType) {
            case DOT1:
            case LEFT1:
            case LEFT2:
            case LEFT3:
            case RIGHT1:
            case RIGHT2:
            case RIGHT3:
                g2D.draw(drawBrush(x,y));
                break;
            default:
            g2D.fill(drawBrush(x,y));    
        }*/
        drawStuff(mevt,x,y,theCanvas);
        theCanvas.repaint();    
    }
    
    public void drawStuff(MouseEvent mevt, int x, int y, main_canvas theCanvas) {
       // Algorithm provided by Po-Han Lin 
       // http://www.edepot.com 
        
        boolean yLonger = false;
	int incrementVal, endVal;

	int shortLen= y - prevY;
	int longLen= x - prevX;
	if (Math.abs(shortLen) > Math.abs(longLen)) {
		int swap = shortLen;
		shortLen = longLen;
		longLen = swap;
		yLonger = true;
	}
	
	endVal = longLen;
	if (longLen < 0) {
		incrementVal = -1;
		longLen = -longLen;
	} else incrementVal =1 ;

	double decInc;
	if (longLen == 0) decInc = (double)shortLen;
	else decInc =((double)shortLen / (double)longLen);
	double j = 0.0;
	if (yLonger) {
		for (int i=0; i !=endVal; i += incrementVal) {
			switch (brushType) {
                            case DOT1:
                                if (SwingUtilities.isLeftMouseButton(mevt)) {
                                    brushImage.setRGB(prevX + (int)j,prevY+i,theCanvas.left_color.getRGB());
                                } else {
                                    brushImage.setRGB(prevX + (int)j,prevY+i,theCanvas.right_color.getRGB());
                                }
                            break;
                            case LEFT1:
                            case LEFT2:
                            case LEFT3:
                            case RIGHT1:
                            case RIGHT2:
                            case RIGHT3:
                                g2D.draw(drawBrush(prevX + (int)j, prevY+i));
                            break;
                            default:
                                g2D.fill(drawBrush(prevX + (int)j,prevY+i));    
                        }           
                        j += decInc;
		}
	} else {
		for (int i=0; i!=endVal; i+= incrementVal) {
			switch (brushType) {
                            case DOT1:
                                if (SwingUtilities.isLeftMouseButton(mevt)) {
                                    brushImage.setRGB(prevX+i,prevY+(int)j,theCanvas.left_color.getRGB());
                                } else {
                                    brushImage.setRGB(prevX+i,prevY+(int)j,theCanvas.right_color.getRGB());
                                }
                            break;
                            case LEFT1:
                            case LEFT2:
                            case LEFT3:
                            case RIGHT1:
                            case RIGHT2:
                            case RIGHT3:
                                g2D.draw(drawBrush(prevX+i,prevY+(int)j));
                            break;
                            default:
                                g2D.fill(drawBrush(prevX+i,prevY+(int)j));    
                        }
                        j+=decInc;
		}
	}
    }

        
    
    public void setBrushType(int type) { brushType = type; }
    
    public Shape drawBrush(int x, int y) {
        Shape brushShape;
        
        switch (brushType) {
            //case DOT1 : brushShape = new Line2D.Double(x,y,x,y);
            //    break;
            case DOT2 :  brushShape = new Ellipse2D.Double(x-2,y-2,4,4);
                break;
            case DOT3 : brushShape = new Ellipse2D.Double(x-4,y-4,8,8);
                break;
            case SQUARE1 : brushShape = new Rectangle(x-1,y-1,2,2);
                break;
            case SQUARE2 : brushShape = new Rectangle(x-2,y-2,5,5);
                break;
            case SQUARE3 : brushShape = new Rectangle(x-4,y-4,8,8);
                break;
            case RIGHT1 : brushShape = new Line2D.Double(x,y+1,x+1,y);
                break;
            case RIGHT2 : brushShape = new Line2D.Double(x-2,y+2,x+2,y-2);
                break;
            case RIGHT3 : brushShape = new Line2D.Double(x-4,y+4,x+4,y-4);
                break;
            case LEFT1 : brushShape = new Line2D.Double(x+1,y+1,x,y);
                break;
            case LEFT2 : brushShape = new Line2D.Double(x-2,y-2,x+2,y+2);
                break;
            case LEFT3 : brushShape = new Line2D.Double(x-4,y-4,x+4,y+4);
                break;
            default : brushShape = new Rectangle(x-5,y-5,x+5,y+5);
        } 
        return brushShape;
    }
    
}




