//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//CMSC435  FunctionsMenuOp (some of the code is adapted from
//                          SharpTools project )
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import java.util.*;

//****************************************************************
// Class: FunctionsMenuOp
// Description:  This class will implement all the functions for the
//               functions menu
//Disclaimer: Some of the code and and ideas we found online in
//            the ShartTools project.  We thank them for making
//            their code availible.
//*************************************************************

public class FunctionsMenuOp
{
    UMSpreadSheet m_spreadsheet;
    private JTable table;
    private UMTableModel tablemodel;
    private CellPoint copypt=new CellPoint(UMSpreadSheet.m_baseRow, UMSpreadSheet.m_baseCol);

    //************************************************************
    // Public Constructor: FunctionsMenuOp
    // Description: This constructs the FunctionsMenuOp and set the parent
    //              application
    //
    // Parameters:
    //     spreadsheet   - the UMSpreadSheet application
    //*************************************************************
    public FunctionsMenuOp(UMSpreadSheet spreadsheet)
    {
     	m_spreadsheet = spreadsheet;
        table=spreadsheet.getTable();
        tablemodel=spreadsheet.getTableModel();
    }

    //***************************************************************
    // Public Method: sumOp
    // Description: This will perform the sum operation for one or more cells
    //**************************************************************
    public void sumOp()
    {

      if(table.getSelectedRowCount() != 0){
        String text;
        CellRange range= new CellRange(table.getSelectedRows(), table.getSelectedColumns());
        StringBuffer buff=new StringBuffer();
        int startRow=table.getSelectedRow();
        int startCol=table.getSelectedColumn();
        int numrows=table.getSelectedRowCount();
        int numcols=table.getSelectedColumnCount();

        String temp=new String();
        temp = temp + ("=SUM(");
        int x=0,y=0,count =0;

        //Calculating the range of cells and generate a formula for sun
        for(x=0; x<numcols; x++)
          for(y=0;y<numrows;y++)
            {
              if(x!=numcols-1 || y!=numrows-1){
              if(count != 0)
               temp = temp+ ",";
              char tempChar = 'A';
              tempChar += (startCol + x -1);
              temp += tempChar  + (Integer.toString(y+startRow+1));
              System.out.println(tempChar);
              count++;

            }
        }
        temp += ")";
        tablemodel.doSetValueAt(temp,startRow+numrows-1,startCol+numcols-1);
      }
    }
    //***************************************************************
    // Public Method: averageOp
    // Description: This will perform the average operation for one or more cells
    //**************************************************************
    public void averageOp()
    {
      if(table.getSelectedRowCount() != 0){
        String text;
        CellRange range= new CellRange(table.getSelectedRows(), table.getSelectedColumns());
        StringBuffer buff=new StringBuffer();
        int startRow=table.getSelectedRow();
        int startCol=table.getSelectedColumn();
        int numrows=table.getSelectedRowCount();
        int numcols=table.getSelectedColumnCount();

        String temp=new String();
        temp = temp + ("=AVERAGE(");
        int x=0,y=0,count =0;

        //Calculating the range of cells and generate a formula for average
        for(x=0; x<numcols; x++)
          for(y=0;y<numrows;y++)
            {
              if(x!=numcols-1 || y!=numrows-1){
              if(count != 0)
               temp = temp+ ",";
              char tempChar = 'A';
              tempChar += (startCol + x -1);
              temp += tempChar  + (Integer.toString(y+startRow+1));
              System.out.println(tempChar);
              count++;

            }
        }
        temp += ")";
        tablemodel.doSetValueAt(temp,startRow+numrows-1,startCol+numcols-1);
      }
    }

    //***************************************************************
    // Public Method: minOp
    // Description: This will perform the min operation one or more cells
    //**************************************************************
    public void minOp()
    {
     if(table.getSelectedRowCount() != 0){
        String text;
        CellRange range= new CellRange(table.getSelectedRows(), table.getSelectedColumns());
        StringBuffer buff=new StringBuffer();
        int startRow=table.getSelectedRow();
        int startCol=table.getSelectedColumn();
        int numrows=table.getSelectedRowCount();
        int numcols=table.getSelectedColumnCount();

        String temp=new String();
        temp = temp + ("=MAX(");
        int x=0,y=0,count =0;

         //Calculating the range of cells and generate a formula for min operation
        for(x=0; x<numcols; x++)
          for(y=0;y<numrows;y++)
            {
              if(x!=numcols-1 || y!=numrows-1){
              if(count != 0)
               temp = temp+ ",";
              char tempChar = 'A';
              tempChar += (startCol + x -1);
              temp += tempChar  + (Integer.toString(y+startRow+1));
              System.out.println(tempChar);
              count++;

            }
        }
        temp += ")";
        tablemodel.doSetValueAt(temp,startRow+numrows-1,startCol+numcols-1);
      }
    }
    //***************************************************************
    // Public Method: maxOp
    // Description: This will perform the max operation for one or more cells
    //**************************************************************
    public void maxOp()
    {
     if(table.getSelectedRowCount() != 0){
        String text;
        CellRange range= new CellRange(table.getSelectedRows(), table.getSelectedColumns());
        StringBuffer buff=new StringBuffer();
        int startRow=table.getSelectedRow();
        int startCol=table.getSelectedColumn();
        int numrows=table.getSelectedRowCount();
        int numcols=table.getSelectedColumnCount();

        String temp=new String();
        temp = temp + ("=MAX(");
        int x=0,y=0,count =0;

         //Calculating the range of cells and generate a formula for max operation
        for(x=0; x<numcols; x++)
          for(y=0;y<numrows;y++)
            {
              if(x!=numcols-1 || y!=numrows-1){
              if(count != 0)
               temp = temp+ ",";
              char tempChar = 'A';
              tempChar += (startCol + x -1);
              temp += tempChar  + (Integer.toString(y+startRow+1));
              System.out.println(tempChar);
              count++;

            }
        }
        temp += ")";
        tablemodel.doSetValueAt(temp,startRow+numrows-1,startCol+numcols-1);
      }
    }
    //***************************************************************
    // Public Method: sqrtOp
    // Description: This will perform the square root operation for one or more cells
    //**************************************************************
    public void sqrtOp()
    {

      if(table.getSelectedRowCount() != 0){
        String text;
        CellRange range= new CellRange(table.getSelectedRows(), table.getSelectedColumns());
        StringBuffer buff=new StringBuffer();
        int startRow=table.getSelectedRow();
        int startCol=table.getSelectedColumn();
        int numrows=table.getSelectedRowCount();
        int numcols=table.getSelectedColumnCount();

        String temp=new String();
        temp = temp + ("=SQRT(");
        int x=0,y=0,count =0;

        //Calculating the range of cells and generate a formula square root operation
        for(x=0; x<numcols; x++)
          for(y=0;y<numrows;y++)
            {
              if(x!=numcols-1 || y!=numrows-1){
              if(count != 0)
               temp = temp+ ",";
              char tempChar = 'A';
              tempChar += (startCol + x -1);
              temp += tempChar  + (Integer.toString(y+startRow+1));
              System.out.println(tempChar);
              count++;

            }
        }
        temp += ")";
        if (count <=1)
          tablemodel.doSetValueAt(temp,startRow+numrows-1,startCol+numcols-1);
        else{
          UMOptionPane.showMessageDialog(m_spreadsheet,
				       "Too Many Cells are Selected !!!",
                                       "Square Root Operation",
				       JOptionPane.WARNING_MESSAGE,
				       null);
        }
      }

    }
    //***************************************************************
    // Public Method: sineOp
    // Description: This will perform the sine operation one or more cells
    //**************************************************************
    public void sineOp()
    {
      if(table.getSelectedRowCount() != 0){
        String text;
        CellRange range= new CellRange(table.getSelectedRows(), table.getSelectedColumns());
        StringBuffer buff=new StringBuffer();
        int startRow=table.getSelectedRow();
        int startCol=table.getSelectedColumn();
        int numrows=table.getSelectedRowCount();
        int numcols=table.getSelectedColumnCount();

        String temp=new String();
        temp = temp + ("=SIN(");
        int x=0,y=0,count =0;

         //Calculating the range of cells and generate a formula for Sine operation
        for(x=0; x<numcols; x++)
          for(y=0;y<numrows;y++)
            {
              if(x!=numcols-1 || y!=numrows-1){
              if(count != 0)
               temp = temp+ ",";
              char tempChar = 'A';
              tempChar += (startCol + x -1);
              temp += tempChar  + (Integer.toString(y+startRow+1));
              System.out.println(tempChar);
              count++;

            }
        }
        temp += ")";
        if(count <=1)
         tablemodel.doSetValueAt(temp,startRow+numrows-1,startCol+numcols-1);
        else{
          UMOptionPane.showMessageDialog(m_spreadsheet,
				       "Too Many Cells are Selected !!!",
                                       "Sine Operation",
				       JOptionPane.WARNING_MESSAGE,
				       null);
        }
      }
    }



    //***************************************************************
    // Public Method: countOp
    // Description: This will perform the count operation for one or more ccells
    //**************************************************************
    public void countOp()
    {
         if(table.getSelectedRowCount() != 0){
        String text;
        CellRange range= new CellRange(table.getSelectedRows(), table.getSelectedColumns());
        StringBuffer buff=new StringBuffer();
        int startRow=table.getSelectedRow();
        int startCol=table.getSelectedColumn();
        int numrows=table.getSelectedRowCount();
        int numcols=table.getSelectedColumnCount();

        String temp=new String();
        temp = temp + ("=COUNT(");
        int x=0,y=0,count =0;


        //Calculating the range of cells and generate a formula for count operation
        for(x=0; x<numcols; x++)
          for(y=0;y<numrows;y++)
            {
              if(x!=numcols-1 || y!=numrows-1){
              if(count != 0)
               temp = temp+ ",";
              char tempChar = 'A';
              tempChar += (startCol + x -1);
              temp += tempChar  + (Integer.toString(y+startRow+1));
              System.out.println(tempChar);
              count++;

            }
        }
        temp += ")";
        tablemodel.doSetValueAt(temp,startRow+numrows-1,startCol+numcols-1);
      }
    }

}
//-------------------------------------------------------------------------------






